///home/berryj/link/bin/genMethods "-g" "-t" "Set<Vertex*>" "-h" "Collection" "-c" "Vertex*" "-I" "LINK/graph/Vertex.h" "-I" "LINK/stkWrapper/SetFuncsWrapper.h" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Set.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Vertex.h>

#include <LINK/stkWrapper/SetFuncsWrapper.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Set.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Set<Vertex*> _Set_Vertex__;
typedef Collection<Set<Vertex*> > _Collection_Set_Vertex___;

#define _Collection_Set_Vertex___DATA(x) ((Collection<Set<Vertex*> >*) (EXTDATA(x)))
#define _Collection_Set_Vertex___IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Set<Vertex*> > >::type))
#define _Collection_Set_Vertex___ISNT_DATA(x) (!_Collection_Set_Vertex___IS_DATA(x))

#define _Collection_Set_Vertex___CXX_DATA(x) (*(Collection<Set<Vertex*> >*) (EXTDATA(VAL(x))))
#define _Collection_Set_Vertex___CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Set<Vertex*> > >::type))
#define _Collection_Set_Vertex___CXX_ISNT_DATA(x) (!_Collection_Set_Vertex___CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_Set_Vertex___()
{
	Wrapper<_Collection_Set_Vertex___>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_Set_Vertex___>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Set_Vertex__>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Set_Vertex__>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Set_Vertex__>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_Set_Vertex___>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_Set_Vertex___Methods(void);

PRIMITIVE STk_init_methods__Collection_Set_Vertex___()
{
	STk_add_new_cpp_primitive("collection-Set-Vertex?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::collectionP);
	STk_add_new_cpp_primitive("mset-Set-Vertex1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::buildMSet);
	STk_add_new_cpp_primitive("set-Set-Vertex1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::buildSet);
	STk_add_new_cpp_primitive("sequence-Set-Vertex1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::buildSequence);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-Set-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-Set-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-Set-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-Set-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::collection2STkList);
	STk_add_new_cpp_primitive("set-Set-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-Set-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::collection2STkList);
	STk_add_new_cpp_primitive("mset-Set-Vertex->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::collection2STkString);
	STk_add_new_cpp_primitive("set-Set-Vertex->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-Set-Vertex->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Vertex__>::collection2STkString);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-cartesian-product", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::cartesianProduct);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-choose", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::choose);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-power-set", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::powerSet);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-permutations", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::permutations);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-permutation", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::permutation);
	STk_add_new_cpp_primitive("Collection-Set-Vertex-permutation-rank", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::rank);

	addListMethod("mset-Set-Vertex",
		"mset-Set-Vertex1", LINK_NEW);
	addListMethod("set-Set-Vertex",
		"set-Set-Vertex1", LINK_NEW);
	addListMethod("sequence-Set-Vertex",
		"sequence-Set-Vertex1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_Set_Vertex__ >::name, 
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"<integer>",
		"Collection-Set-Vertex-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_Set_Vertex__ >::name, 
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_Set_Vertex__ >::name, 
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_Set_Vertex__ >::name, 
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_Set_Vertex___ >::name, 
		"Collection-Set-Vertex--", LINK_OVL);
	addTwoArgMethod("cartesian-product",
		Wrapper<_Set_Vertex__ >::name, 
		Wrapper<_Set_Vertex__ >::name, 
		"Collection-Set-Vertex-cartesian-product", LINK_NEW);
	addTwoArgMethod("choose",
		Wrapper<_Set_Vertex__ >::name, 
		"<integer>",
		"Collection-Set-Vertex-choose", LINK_NEW);
	addOneArgMethod("power-set",
		Wrapper<_Set_Vertex__ >::name, 
		"Collection-Set-Vertex-power-set", LINK_NEW);
	addOneArgMethod("permutations",
		Wrapper<_Set_Vertex__ >::name, 
		"Collection-Set-Vertex-permutations", LINK_NEW);
	addTwoArgMethod("permutation",
		Wrapper<_Set_Vertex__ >::name, 
		"<integer>",
		"Collection-Set-Vertex-permutation", LINK_NEW);
	addOneArgMethod("permutation-rank",
		Wrapper<_Set_Vertex__ >::name, 
		"Collection-Set-Vertex-permutation-rank", LINK_NEW);
	genExtra_Collection_Set_Vertex___Methods();
	return UNDEFINED;
}
